<?php 
/*
Plugin Name: My Sites Shortcode
Plugin URI: http://wordpress.org/extend/plugins/user-avatar/
Description: Use to display a list of links to tyier sites once they are logged in. 
Version: 1
Author: Enej Bajgoric / CTLT DEV


GNU General Public License, Free Software Foundation <http://creativecommons.org/licenses/GPL/2.0/>
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


add_shortcode("my-sites", "my_sites_shortcode");

function my_sites_shortcode($atts)
{
	global $current_user;
	extract(shortcode_atts(array(
	      'before' 		=> '',
	      'loggedout' 	=> '',
	      'images'		=>null,
	      'image_size'	=>130,
	      'role'		=>null,
	      'num_before_list'=>5
     ), $atts));
	
	if($current_user->id):
		$blogs = get_blogs_of_user( $current_user->id );
		
		if( !is_numeric($image_size) )
			$image_size = 130;
		
		$i = 0;
		
		$sites = '<div class="my-sites">'.do_shortcode($before).'<ul class="my-sites-list">';
		$blog_id 		= $current_user->primary_blog;
		$blog_details 	= get_blog_details( $blog_id );
		$siteurl 		= $blog_details->siteurl;
		$blog_name 		= $blog_details->blogname;
		
		if($blog_id == 1)
			$wp_cap_text = 'wp_capabilities';
		else
			$wp_cap_text = 'wp_'.$blog_id.'_capabilities';
					
		if(!is_null($role)):
			$role_name = array_keys($current_user->$wp_cap_text);
			$role_name = $role_name[0];
			
			if(	$role_name != "subscriber" ):
				$role_html = 'role: <strong class="site-role">'.$role_name.'</strong>';
			else:
				$role_html = '';
			endif;
		endif;
		
		if($i < $num_before_list && !is_null($images) ):
			$sites  .= '<li class="my-site odd"> <a href="'.esc_html($siteurl).'" class="site-link site-link-image"><img src="http://s.wordpress.com/mshots/v1/'.urlencode($siteurl).'?w='.$image_size.'" alt="'.esc_attr($blog_name).'" class="site-image" width="'.$image_size.'"/></a> <h3 class="site-name"><a href="'.esc_html($siteurl).'" class="site-link">'.$blog_name.'</a></h3><a href="'.esc_url( get_admin_url( $blog_id ) ).'" class="site-dashboard">Dashboard</a> '.$role_html.'</li>';
		else:
		 	$sites  .= '<li class="my-site odd"> <h3 class="site-name"><a href="'.$siteurl.'" class="site-link">'.$blog_name.'</a></h3><a href="'.esc_url( get_admin_url( $blog_id ) ).'">Dashboard</a> '.$role_html.'</li>';
		endif;
		$i++;
		
		foreach($blogs as $site):
			
			if($site->userblog_id == $blog_id)
				continue; // prevents from repeating the 
			
			$odd_or_even = 'odd';
			if($i%2)
				$odd_or_even = 'even';
			
			if($site->userblog_id == 1)
				$wp_cap_text = 'wp_capabilities';
			else
				$wp_cap_text = 'wp_'.$site->userblog_id.'_capabilities';
						
			if(!is_null($role)):
				$role_name = array_keys($current_user->$wp_cap_text);
				$role_name = $role_name[0];
				
				if(	$role_name != "subscriber" ):
					$role_html = 'role: <strong class="site-role">'.$role_name.'</strong>';
				else:
					$role_html = '';
				endif;
			endif;
			
			if($i < $num_before_list && !is_null($images) ):
				$sites  .= '<li class="my-site '.$odd_or_even.'"> <a href="'.esc_html($site->siteurl).'" class="site-link site-link-image"><img src="http://s.wordpress.com/mshots/v1/'.urlencode($site->siteurl).'?w='.$image_size.'" alt="'.esc_attr($site->blogname).'" class="site-image" width="'.$image_size.'"/></a> <h3 class="site-name"><a href="'.esc_html($site->siteurl).'" class="site-link">'.$site->blogname.'</a></h3><a href="'.esc_url( get_admin_url( $site->userblog_id ) ).'" class="site-dashboard">Dashboard</a> '.$role_html.'</li>';
			else:
			 	$sites  .= '<li class="my-site '.$odd_or_even.'"> <h3 class="site-name"><a href="'.$site->siteurl.'" class="site-link">'.$site->blogname.'</a></h3><a href="'.esc_url( get_admin_url( $site->userblog_id ) ).'">Dashboard</a> '.$role_html.'</li>';
			endif;
			$i++;
		endforeach;
		$sites .= "</ul></div>";
		
	else:
		$sites = "<div class='loggedout'>".do_shortcode($loggedout)."</div>";
	endif;
	return $sites;

}